* Write Sprite
* Simple wrapper for iop.wspt
* V0.00, pjw, December 9th 2016


        section code

        filetype 0

*       include dev8_keys_qlv
*       include dev8_keys_sbasic
*       include dev8_keys_qdos_io
*       include dev8_keys_err

sb.inipr equ    $0110           ; INITialise PRocedure table
sb.gtint equ    $0112           ; GeT INTeger
sb.gtlin equ    $0118           ; GeT Long INteger

nt..hash equ        7           ; preceded by hash
ch.len   equ      $28
sb_chanb equ      $30           ; long    channel table base
sb_chanp equ      $34           ; long    ... and pointer
sb_arthp equ      $58           ; long    arithmetic stack pointer

iop.wspt equ      $76           ; write sprite

err.ichn equ       -6           ; Invalid CHaNnel id
err.ipar equ      -15           ; Invalid PARameter (c.f. err.orng)

forever  equ       -1           ; timeout

*
* Initialise keyword
*
        lea.l   key,a1
        move.w  sb.inipr,a2     link in procedure and
        jmp     (a2)             return to BASIC

*
* Usage: WSPT#ch; x%, y%, addr
*
* Write sprite at addr to (screen)channel #ch, at x-pos, y-pos

key
        dc.w 1                  one PROCedure
        dc.w WSPT-*
        dc.b 4,'WSPT '          name with padding to even
        dc.w 0                  end procs
        dc.w 0,0                no FuNctions, end fns

*
WSPT
*
* Check and get parameters
*
        lea.l 4*8(a3),a4
        cmpa.l a4,a5            four parameters?
        bne.s err_bp             not. Thats wrong

        btst #nt..hash,1(a6,a3.l) has first parameter a hash?
        beq.s err_ch             nope, grumble

        subq.l #8,a5            leave out last par for now..

        move.w sb.gtint,a2      GeT INTeger(s)
        jsr (a2)                get first three integers
        bne.s quit

        move.w 0(a6,a1.l),d6    get #ch
        move.l 2(a6,a1.l),d5    keep x/y safe
        addq.l #6,sb_arthp(a6)  reset stack pointer

* Now get sprite address

        movea.l a5,a3           bracket last parameter
        addq.l #8,a5             restore end pointer

        move.w sb.gtlin,a2      GeT Long INteger
        jsr (a2)
        bne.s quit

        movea.l 0(a6,a1.l),a1   got sprite address - no checking..

*
* Convert S*Basic channel number to system channel ID
*
        mulu #ch.len,d6         convert d6 to long pointer to channel table
        add.l sb_chanb(a6),d6   channel table base
        cmp.l sb_chanp(a6),d6   is it within the table?
        bge.s err_ch             no

        move.l 0(a6,d6.l),a0    thats channel ID in place

        move.l d5,d1            put x/y in place - no checking..

*
* Now, with any luck: Draw the sprite
*
*
        moveq #forever,d3       timeout
        moveq #iop.wspt,d0      write sprite trap
        trap #3

        tst.l d0

quit
        rts

err_ch
        moveq #err.ichn,d0
        rts

err_bp
        moveq #err.ipar,d0
        rts

*
        end
